Mirror of the gdb-patches mailing list
 help / color / mirror / Atom feed
From: Simon Marchi <simon.marchi@ericsson.com>
To: "gdb-patches@sourceware.org" <gdb-patches@sourceware.org>
Cc: Sergio Durigan Junior <sergiodj@redhat.com>,
	Simon Marchi	<simon.marchi@ericsson.com>
Subject: [PATCH] Carry the gnulib getcwd backport as a patch
Date: Tue, 18 Sep 2018 21:21:00 -0000	[thread overview]
Message-ID: <20180918212124.5851-1-simon.marchi@ericsson.com> (raw)

Commit

  e2fc52e7457 ("Fix PR gdb/23558: Use system's 'getcwd' when cross-compiling GDB")

backported some changes from a future gnulib version to our import.
However, this means that every time someone wants to change our gnulib
import (e.g. add a module), they must make sure not to include that
backported change.  It also means that someone running the
update-gnulib.sh script without changes will get some diffs and wonder
why.

Instead, I suggest we carry that backport as a patch applied by the
update-gnulib.sh script after running the import tool.  It will make it
clear what backport or local modification we have and should make
running update-gnulib.sh give a reproducible result.

There is a hunk in the configure file in this patch, this is because the
commit that backported the getcwd bits didn't include the re-generated
configure.

Note: you'll need this patch as well to get deterministic results:

  Generate aclocal-m4-deps.mk more deterministically and portably.
  https://sourceware.org/ml/gdb-patches/2018-09/msg00643.html

gdb/ChangeLog:

	* patches/0001-Fix-PR-gdb-23558-Use-system-s-getcwd-when-cross-comp.patch:
	New file.
	* update-gnulib.sh: Apply patch.
	* configure: Re-generate.
---
 gdb/gnulib/configure                          | 18 ++++-
 ...-Use-system-s-getcwd-when-cross-comp.patch | 69 +++++++++++++++++++
 gdb/gnulib/update-gnulib.sh                   | 12 ++++
 3 files changed, 96 insertions(+), 3 deletions(-)
 create mode 100644 gdb/gnulib/patches/0001-Fix-PR-gdb-23558-Use-system-s-getcwd-when-cross-comp.patch

diff --git a/gdb/gnulib/configure b/gdb/gnulib/configure
index 8c3027635f5..092db16ba28 100644
--- a/gdb/gnulib/configure
+++ b/gdb/gnulib/configure
@@ -16921,10 +16921,22 @@ else
   # Arrange for deletion of the temporary directory this test creates.
      ac_clean_files="$ac_clean_files confdir3"
           if test "$cross_compiling" = yes; then :
-  case "$host_os" in
-       aix*) gl_cv_func_getcwd_path_max='no, it has the AIX bug';;
-       *) gl_cv_func_getcwd_path_max=no;;
+  # Cross-compilation guesses:
+     case "$host_os" in
+       aix*) # On AIX, it has the AIX bug.
+         gl_cv_func_getcwd_path_max='no, it has the AIX bug' ;;
+       gnu*) # On Hurd, it is 'yes'.
+         gl_cv_func_getcwd_path_max=yes ;;
+       linux* | kfreebsd*)
+         # On older Linux+glibc it's 'no, but it is partly working',
+         # on newer Linux+glibc it's 'yes'.
+         # On Linux+musl libc, it's 'no, but it is partly working'.
+         # On kFreeBSD+glibc, it's 'no, but it is partly working'.
+         gl_cv_func_getcwd_path_max='no, but it is partly working' ;;
+       *) # If we don't know, assume the worst.
+         gl_cv_func_getcwd_path_max=no ;;
      esac
+
 else
   cat confdefs.h - <<_ACEOF >conftest.$ac_ext
 /* end confdefs.h.  */
diff --git a/gdb/gnulib/patches/0001-Fix-PR-gdb-23558-Use-system-s-getcwd-when-cross-comp.patch b/gdb/gnulib/patches/0001-Fix-PR-gdb-23558-Use-system-s-getcwd-when-cross-comp.patch
new file mode 100644
index 00000000000..1d8cdf6b901
--- /dev/null
+++ b/gdb/gnulib/patches/0001-Fix-PR-gdb-23558-Use-system-s-getcwd-when-cross-comp.patch
@@ -0,0 +1,69 @@
+From a7447215cdc492a077732420a3f0db6d48b34d51 Mon Sep 17 00:00:00 2001
+From: Sergio Durigan Junior <sergiodj@redhat.com>
+Date: Mon, 10 Sep 2018 12:52:04 -0400
+Subject: [PATCH] Fix PR gdb/23558: Use system's 'getcwd' when cross-compiling
+ GDB
+
+This is a backport of a gnulib fix for the following bug:
+
+  https://sourceware.org/bugzilla/show_bug.cgi?id=23558
+
+The problem reported there is about the replacement of 'getcwd' when
+cross-compiling GDB.  With our current gnulib copy, the mechanism for
+deciding whether to use the system's 'getcwd' or gnulib's version is
+too simplistic and pessimistic, so when cross-compiling we always end
+up using gnulib's version, which has a limitation: it cannot handle
+the situation when the parent directory doesn't have read permissions.
+
+The solution is to backport the following gnulib commit:
+
+  commit a96d2e67052c879b1bcc5bc461722beac75fc372
+  Author: Bruno Haible <bruno@clisp.org>
+  Date:   Thu Aug 23 21:13:19 2018 +0200
+
+      getcwd: Add cross-compilation guesses.
+
+gdb/ChangeLog:
+2018-09-10  Sergio Durigan Junior  <sergiodj@redhat.com>
+
+	PR gdb/23555
+	PR gdb/23558
+	* gnulib/import/m4/getcwd-path-max.m4: Add cross-compilation
+	guesses.
+---
+ gdb/gnulib/import/m4/getcwd-path-max.m4 | 20 ++++++++++++++++----
+ 1 file changed, 16 insertions(+), 4 deletions(-)
+
+diff --git a/gdb/gnulib/import/m4/getcwd-path-max.m4 b/gdb/gnulib/import/m4/getcwd-path-max.m4
+index 2531ccff65c..90bbc77dea1 100644
+--- a/gdb/gnulib/import/m4/getcwd-path-max.m4
++++ b/gdb/gnulib/import/m4/getcwd-path-max.m4
+@@ -209,9 +209,21 @@ main ()
+      32) gl_cv_func_getcwd_path_max='yes, but with shorter paths';;
+      *) gl_cv_func_getcwd_path_max=no;;
+      esac],
+-    [case "$host_os" in
+-       aix*) gl_cv_func_getcwd_path_max='no, it has the AIX bug';;
+-       *) gl_cv_func_getcwd_path_max=no;;
+-     esac])
++    [# Cross-compilation guesses:
++     case "$host_os" in
++       aix*) # On AIX, it has the AIX bug.
++         gl_cv_func_getcwd_path_max='no, it has the AIX bug' ;;
++       gnu*) # On Hurd, it is 'yes'.
++         gl_cv_func_getcwd_path_max=yes ;;
++       linux* | kfreebsd*)
++         # On older Linux+glibc it's 'no, but it is partly working',
++         # on newer Linux+glibc it's 'yes'.
++         # On Linux+musl libc, it's 'no, but it is partly working'.
++         # On kFreeBSD+glibc, it's 'no, but it is partly working'.
++         gl_cv_func_getcwd_path_max='no, but it is partly working' ;;
++       *) # If we don't know, assume the worst.
++         gl_cv_func_getcwd_path_max=no ;;
++     esac
++    ])
+   ])
+ ])
+-- 
+2.19.0
+
diff --git a/gdb/gnulib/update-gnulib.sh b/gdb/gnulib/update-gnulib.sh
index 3077424622b..dff1254830b 100755
--- a/gdb/gnulib/update-gnulib.sh
+++ b/gdb/gnulib/update-gnulib.sh
@@ -157,6 +157,18 @@ if [ $? -ne 0 ]; then
    exit 1
 fi
 
+# Apply our local patches.
+apply_patches ()
+{
+    patch -p3 -f -i "$1"
+    if [ $? -ne 0 ]; then
+        echo "Failed to apply some patches.  Aborting."
+        exit 1
+    fi
+}
+
+apply_patches "patches/0001-Fix-PR-gdb-23558-Use-system-s-getcwd-when-cross-comp.patch"
+
 # Regenerate all necessary files...
 aclocal -Iimport/m4 &&
 autoconf &&
-- 
2.19.0


             reply	other threads:[~2018-09-18 21:21 UTC|newest]

Thread overview: 7+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2018-09-18 21:21 Simon Marchi [this message]
2018-09-18 21:33 ` John Baldwin
2018-09-18 21:39 ` Tom Tromey
2018-09-18 21:49   ` Simon Marchi
     [not found]     ` <87woriqxmj.fsf@tromey.com>
2018-09-18 21:59       ` Simon Marchi
2018-09-19  2:42         ` Sergio Durigan Junior
2018-09-19  3:49           ` Simon Marchi

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20180918212124.5851-1-simon.marchi@ericsson.com \
    --to=simon.marchi@ericsson.com \
    --cc=gdb-patches@sourceware.org \
    --cc=sergiodj@redhat.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox